"""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
import os
from resourcemanager import ResourceManager

__imgbase = "." + os.sep + "enemies" + os.sep
__soundbase = "." + os.sep

enemycfgs = {
	"scorpion1" :{
							"name":      	"Scorpion",
							"image_w":  	50,
							"image_tr":  	ResourceManager.get_image(__imgbase + "scorpion1_tr.png"),
							"image_tl":     ResourceManager.get_image(__imgbase + "scorpion1_tl.png"),
							"death_sound":  ResourceManager.get_sound(__soundbase + "scorpion_death.wav"),
							"amor":			["fire"],
							"movement":		"earth",
							"hp":    		100,
							"res":  		5,
							"speed":	    2000,
							# Specifies the resistance the bug has against a certain type of damage in percent.
							# In case of an attack, the respective resistance is subtracted from the amount
							# of damage that the tower would inflict otherwise.
							# If resistance to a damage type is not specified, it defaults to 0.
							"resistance":   { "chemical":20, "impact":30, "biological":10 },
			},
	"scorpion2" :{
							"name":      	"Deadly Scorpion",
							"image_w":  	60,
							"image_tr":  	ResourceManager.get_image(__imgbase + "scorpion2_tr.png"),
							"image_tl":     ResourceManager.get_image(__imgbase + "scorpion2_tl.png"),
							"death_sound":  ResourceManager.get_sound(__soundbase + "scorpion_death.wav"),
							"amor":			["fire"],
							"movement":		"earth",
							"hp":    		150,
							"res":  		7,
							"speed":	    2200,
							"resistance":   { "chemical":20, "impact":60, "biological":0 },
			},
	"spider1" :{
							"name":      	"Spider",
							"image_w":  	55,
							"image_tr":  	ResourceManager.get_image(__imgbase + "spider1_tr.png"),
							"image_tl":     ResourceManager.get_image(__imgbase + "spider1_tl.png"),
							"death_sound":  ResourceManager.get_sound(__soundbase + "scorpion_death.wav"),
							"amor":			["water"],
							"movement":		"earth",
							"hp":    		150,
							"res":  		5,
							"speed":     	6000,
							"resistance":   { "chemical":10, "impact":0, "biological":10 },
			},
	"spider2" :{
							"name":      	"Fast Spider",
							"image_w":  	30,
							"image_tr":  	ResourceManager.get_image(__imgbase + "spider2_tr.png"),
							"image_tl":     ResourceManager.get_image(__imgbase + "spider2_tl.png"),
							"death_sound":  ResourceManager.get_sound(__soundbase + "scorpion_death.wav"),
							"amor":			["water"],
							"movement":		"earth",
							"hp":    		150,
							"res":  		6,
							"speed":     	6000,
							"resistance":   { "chemical":50, "impact":0, "biological":10 },
			},
	"mouse" :{		"name":      	"Mouse",
					"image_w":  	56,
					"image_tr":  	ResourceManager.get_image(__imgbase + "mouse_tr.png"),
					"image_tl":     ResourceManager.get_image(__imgbase + "mouse_tl.png"),
					"death_sound":  ResourceManager.get_sound(__soundbase + "scorpion_death.wav"),
					"amor":			["physical"],
					"movement":		"earth",
					"hp":    		190,
					"res":  		7,
					"speed":     	10000,
					"resistance":   { "chemical":30, "impact":0, "biological":90 },
				}
}