"""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
""""""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

import pygame, os

from drawables import Drawable

from resourcemanager import ResourceManager

from drawables import Drawable
class MenuItem(Drawable):
    """Abstraction class for all menu items."""
    def __init__(self, imageActive, imageInactive, enabled=False):
        Drawable.__init__(self)
        self.enabled = enabled
        
        self.active = False
        self.position = (0,0)
        self.actions = {}
        
        self.imageActive = ResourceManager.get_image("menu" + os.sep + imageActive)
        self.imageInactive = ResourceManager.get_image("menu" + os.sep + imageInactive)       
        self.set_image()

    def change_state(self):
        if self.active:
            self.deactivate()
        else:
            self.activate()
    
    def update(self, tick):
        pass
    
    def set_position(self, position, update=True):
        self.position = position
        self.set_image()
        if update:
            self.update()
    
    def set_image(self):
        """Sets the image that should be shown."""
        if self.active:
            self.image = self.imageActive
        else:
            self.image = self.imageInactive
        
        self.rect = self.image.get_rect()
        self.rect.x = self.position[0]
        self.rect.y = self.position[1]
    
    def activate(self):
        """Activates the item.
        
        @return True, if it is enabled, False otherwise.
        """
        if self.enabled:
            self.active = True
            self.set_image()
        
        return self.active
    
    def deactivate(self):
        """Deactivates the item.
        
        @return True, if it is enabled, False otherwise.
        """
        if self.enabled:
            self.active = False
            self.set_image()
        
        return self.active
    
    def add_action(self, actionItem=None, actionKey=pygame.K_RETURN):
        self.actions[actionKey] = actionItem
    
    def action(self, actionKey):
        if actionKey and actionKey in self.actions:
            self.actions[actionKey]()
            
    def update(self, tick):
        pass




class MenuItemSelector(MenuItem):
    def __init__(self, itemdict = None, enabled=False, name=None):
        """
        @param itemdict {value -> item}
        """
        MenuItem.__init__(self, "selector" + os.sep + "selector_active.png", "selector" + os.sep + "selector_inactive.png", enabled, name)
        