"""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
# Highly inspired by Timothy Downs, inputbox
import pygame, pygame.font, pygame.event, pygame.draw, string
from pygame.locals import *

from resourcemanager import ResourceManager
def get_key():
  while 1:
    event = pygame.event.poll()
    if event.type == KEYDOWN:
      return event.key
    else:
      pass

def display_box(screen, message, name):
  "Print a message in a box in the middle of the screen"
  fontobject = ResourceManager.get_font(20)
  pygame.draw.rect(screen, (128,128,128,200),
                   ((screen.get_width() / 2) - 100,
                    (screen.get_height() / 2) - 200,
                     200, 190), 0)
  
  pygame.draw.rect(screen, (0,0,0),
                   ((screen.get_width() / 2) - 100,
                    (screen.get_height() / 2) - 10,
                    200,20), 0)
  pygame.draw.rect(screen, (255,255,255),
                   ((screen.get_width() / 2) - 102,
                    (screen.get_height() / 2) - 12,
                    204,24), 1)
  padding = 20
  for msg in message:
    screen.blit(fontobject.render(msg, 1, (255,255,255)),
                ((screen.get_width() / 2) - 100, (screen.get_height() / 2) - 220 + padding))
    padding += 20
  screen.blit(fontobject.render("Your Name: ", 1, (255,255,255)),
                ((screen.get_width() / 2) - 100, (screen.get_height() / 2) - 180 + padding))
  if len(name) != 0:
    screen.blit(fontobject.render(name, 1, (255,255,255)),
                ((screen.get_width() / 2) - 100, (screen.get_height() / 2) - 10))
  pygame.display.flip()

def showScore(screen, scoreMsgs):
  current_string = []
  display_box(screen, scoreMsgs, "Your Name: " + string.join(current_string,""))
  while 1:
    inkey = get_key()
    if inkey == K_BACKSPACE:
      current_string = current_string[0:-1]
    elif inkey == K_RETURN:
      break
    elif inkey <= 127:
      c = unichr(inkey)
      
      #TODO Fix me! I'm a Hack How to get actual meaning for keycode
      if c == "z":
        current_string.append("y")
      elif c == "y":
        current_string.append("z")
      else:
        current_string.append(c)
    display_box(screen, scoreMsgs, string.join(current_string,""))
  return string.join(current_string,"")